Trigger a topology sync for a site
curl --request POST \
--url https://api.example.com/api/v1/sites/{id}/topology-sync/ \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"intent": {
"id": "<string>",
"ttl_seconds": 43200,
"expect_nodes_absent": [
"<string>"
],
"expect_nodes_swapped": [
[
"<string>"
]
]
}
}
'import requests
url = "https://api.example.com/api/v1/sites/{id}/topology-sync/"
payload = { "intent": {
"id": "<string>",
"ttl_seconds": 43200,
"expect_nodes_absent": ["<string>"],
"expect_nodes_swapped": [["<string>"]]
} }
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
intent: {
id: '<string>',
ttl_seconds: 43200,
expect_nodes_absent: ['<string>'],
expect_nodes_swapped: [['<string>']]
}
})
};
fetch('https://api.example.com/api/v1/sites/{id}/topology-sync/', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.example.com/api/v1/sites/{id}/topology-sync/",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'intent' => [
'id' => '<string>',
'ttl_seconds' => 43200,
'expect_nodes_absent' => [
'<string>'
],
'expect_nodes_swapped' => [
[
'<string>'
]
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.example.com/api/v1/sites/{id}/topology-sync/"
payload := strings.NewReader("{\n \"intent\": {\n \"id\": \"<string>\",\n \"ttl_seconds\": 43200,\n \"expect_nodes_absent\": [\n \"<string>\"\n ],\n \"expect_nodes_swapped\": [\n [\n \"<string>\"\n ]\n ]\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.example.com/api/v1/sites/{id}/topology-sync/")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"intent\": {\n \"id\": \"<string>\",\n \"ttl_seconds\": 43200,\n \"expect_nodes_absent\": [\n \"<string>\"\n ],\n \"expect_nodes_swapped\": [\n [\n \"<string>\"\n ]\n ]\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.example.com/api/v1/sites/{id}/topology-sync/")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"intent\": {\n \"id\": \"<string>\",\n \"ttl_seconds\": 43200,\n \"expect_nodes_absent\": [\n \"<string>\"\n ],\n \"expect_nodes_swapped\": [\n [\n \"<string>\"\n ]\n ]\n }\n}"
response = http.request(request)
puts response.read_body{
"region": "<string>",
"status": "started",
"intent": {
"id": "<string>",
"state": "pending",
"expires_at": "2023-11-07T05:31:56Z"
},
"request_id": "<string>"
}{
"detail": "<string>",
"code": "error",
"field_errors": [
{
"field": "<string>",
"messages": [
"<string>"
]
}
]
}{
"detail": "<string>",
"code": "error",
"field_errors": [
{
"field": "<string>",
"messages": [
"<string>"
]
}
]
}{
"detail": "<string>",
"code": "error",
"field_errors": [
{
"field": "<string>",
"messages": [
"<string>"
]
}
]
}{
"detail": "<string>",
"code": "error",
"field_errors": [
{
"field": "<string>",
"messages": [
"<string>"
]
}
]
}{
"detail": "<string>",
"code": "error",
"field_errors": [
{
"field": "<string>",
"messages": [
"<string>"
]
}
]
}{
"detail": "<string>",
"code": "error",
"field_errors": [
{
"field": "<string>",
"messages": [
"<string>"
]
}
]
}{
"detail": "<string>",
"code": "error",
"field_errors": [
{
"field": "<string>",
"messages": [
"<string>"
]
}
]
}Topology Groups
Trigger a topology sync for a site
Declare a Sync Intent on the site’s topology-service Region and trigger a sync. Every declaration triggers a sync; a trigger arriving mid-sync queues one follow-up.
POST
/
api
/
v1
/
sites
/
{id}
/
topology-sync
/
Trigger a topology sync for a site
curl --request POST \
--url https://api.example.com/api/v1/sites/{id}/topology-sync/ \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"intent": {
"id": "<string>",
"ttl_seconds": 43200,
"expect_nodes_absent": [
"<string>"
],
"expect_nodes_swapped": [
[
"<string>"
]
]
}
}
'import requests
url = "https://api.example.com/api/v1/sites/{id}/topology-sync/"
payload = { "intent": {
"id": "<string>",
"ttl_seconds": 43200,
"expect_nodes_absent": ["<string>"],
"expect_nodes_swapped": [["<string>"]]
} }
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
intent: {
id: '<string>',
ttl_seconds: 43200,
expect_nodes_absent: ['<string>'],
expect_nodes_swapped: [['<string>']]
}
})
};
fetch('https://api.example.com/api/v1/sites/{id}/topology-sync/', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.example.com/api/v1/sites/{id}/topology-sync/",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'intent' => [
'id' => '<string>',
'ttl_seconds' => 43200,
'expect_nodes_absent' => [
'<string>'
],
'expect_nodes_swapped' => [
[
'<string>'
]
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.example.com/api/v1/sites/{id}/topology-sync/"
payload := strings.NewReader("{\n \"intent\": {\n \"id\": \"<string>\",\n \"ttl_seconds\": 43200,\n \"expect_nodes_absent\": [\n \"<string>\"\n ],\n \"expect_nodes_swapped\": [\n [\n \"<string>\"\n ]\n ]\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.example.com/api/v1/sites/{id}/topology-sync/")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"intent\": {\n \"id\": \"<string>\",\n \"ttl_seconds\": 43200,\n \"expect_nodes_absent\": [\n \"<string>\"\n ],\n \"expect_nodes_swapped\": [\n [\n \"<string>\"\n ]\n ]\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.example.com/api/v1/sites/{id}/topology-sync/")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"intent\": {\n \"id\": \"<string>\",\n \"ttl_seconds\": 43200,\n \"expect_nodes_absent\": [\n \"<string>\"\n ],\n \"expect_nodes_swapped\": [\n [\n \"<string>\"\n ]\n ]\n }\n}"
response = http.request(request)
puts response.read_body{
"region": "<string>",
"status": "started",
"intent": {
"id": "<string>",
"state": "pending",
"expires_at": "2023-11-07T05:31:56Z"
},
"request_id": "<string>"
}{
"detail": "<string>",
"code": "error",
"field_errors": [
{
"field": "<string>",
"messages": [
"<string>"
]
}
]
}{
"detail": "<string>",
"code": "error",
"field_errors": [
{
"field": "<string>",
"messages": [
"<string>"
]
}
]
}{
"detail": "<string>",
"code": "error",
"field_errors": [
{
"field": "<string>",
"messages": [
"<string>"
]
}
]
}{
"detail": "<string>",
"code": "error",
"field_errors": [
{
"field": "<string>",
"messages": [
"<string>"
]
}
]
}{
"detail": "<string>",
"code": "error",
"field_errors": [
{
"field": "<string>",
"messages": [
"<string>"
]
}
]
}{
"detail": "<string>",
"code": "error",
"field_errors": [
{
"field": "<string>",
"messages": [
"<string>"
]
}
]
}{
"detail": "<string>",
"code": "error",
"field_errors": [
{
"field": "<string>",
"messages": [
"<string>"
]
}
]
}Authorizations
oauth2cookieAuth
The access token received from the authorization server in the OAuth 2.0 flow.
Path Parameters
A UUID string identifying this site.
Body
application/jsonapplication/x-www-form-urlencodedmultipart/form-data
Request to sync a site's topology-service Region, declaring an intent first.
What the first topology-service sync starting after this request should show.
Show child attributes
Show child attributes
Response
topology-service's answer to the sync trigger.